import { DEFAULT_STATE } from "./state";
import { initAnimationDuration } from "./animation";
import { initNumberParser } from "./number-parser";
import { initChartLayout } from "./chart-layout";
import { initXDisabled } from "./x-disabled";
import { initYDisabled } from "./y-disabled";
import { initXExtendByStep } from "./x-extend-by-step";
import { initYExtendByStep } from "./y-extend-by-step";
import { initUpdate } from "./update";
import { initFacetName } from "./facet-name";
import { initAppendTo } from "./append-to";
import { initFontFamily } from "./font-family";
import { initAppendPatternsTo } from "./append-patterns-to";
import { initOffset } from "./offset";

function init(state) {
	for (const key in DEFAULT_STATE) {
		if (state[key] === undefined) state[key] = DEFAULT_STATE[key];
	}


	const instance = {};
	initAnimationDuration(instance);
	initNumberParser(instance);
	initAppendTo(instance);
	initChartLayout(instance);
	initXDisabled(instance);
	initYDisabled(instance);
	initXExtendByStep(instance);
	initYExtendByStep(instance);
	initFacetName(instance);
	initFontFamily(instance);
	initAppendPatternsTo(instance);
	initOffset(instance);
	initUpdate(instance, state);

	return instance;
}
export default init;
